﻿Imports GrapeCity.Windows.SpreadSheet.Data
Imports GrapeCity.Windows.SpreadSheet.UI.UndoRedo
Imports GrapeCity.Windows.SpreadSheet.UI
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes

Partial Public Class MainWindow

    Dim grfGraph() As Worksheet
    Dim chart() As SpreadChart
    Dim chartData() As SpreadDataSeries
    Dim ds As New GrapeCity.Windows.SpreadSheet.Data.SpreadDataSeries()
    Dim btnClick As Boolean

    Private _selectedChart As SpreadChart

    Public Sub New()
        InitializeComponent()
        InitializeSample()
    End Sub

    Private Sub InitializeSample()

        Mult_Graphs()

    End Sub

    Private Sub Mult_Graphs()

        ' btnClick = False
        ' test values
        ds.Values.Add(-3)
        ds.Values.Add(-2)
        ds.Values.Add(-1)
        ds.Values.Add(0)
        ds.Values.Add(1)
        ds.Values.Add(2)
        ds.Values.Add(3)
        ds.Values.Add(4)
        ds.Values.Add(5)
        ds.Values.Add(6)

        Call Init_Graphs()

        If btnClick Then
            ' data series object no longer exists, but chart does not change. 
            ' Adding values after line below causes an exception.
            'ds = Nothing
            '' Had to declare a new Data Series Object in order to add values. Chart display does not change.
            'ds = New GrapeCity.Windows.SpreadSheet.Data.SpreadDataSeries()
            MessageBox.Show(btnClick.ToString)

            ds.Values.Add(6)
            ds.Values.Add(5)
            ds.Values.Add(4)
            ds.Values.Add(3)
            ds.Values.Add(2)
            ds.Values.Add(1)
            ds.Values.Add(0)
            ds.Values.Add(-1)
            ds.Values.Add(-2)
            ds.Values.Add(-3)
            ds.Values.Add(-4)
            ds.Values.Add(-3)
            ds.Values.Add(-2)
            ds.Values.Add(-1)

            ' Call Init_Graphs()

        End If

    End Sub

    Private Sub Init_Graphs()

        ReDim grfGraph(8)
        For i% = 1 To (8)
            ' Set up the GrapeCity SpreadNet worksheet graph displays
            TryCast(Me.FindName("gcSpreadSheet" & i%), GcSpreadSheet).SheetCount = 1
            ' Assign the GrapeCity SpreadNet ActiveSheet to the grfGraph Worksheet
            grfGraph(i%) = TryCast(Me.FindName("gcSpreadSheet" & i%), GcSpreadSheet).Sheets(0)
            grfGraph(i%).RowHeader.IsVisible = False
            grfGraph(i%).ColumnHeader.IsVisible = False
            grfGraph(i%).DefaultStyle.Background = Brushes.Silver
        Next

        ReDim chart(8)
        For i% = 1 To 8
            TryCast(Me.FindName("gcSpreadSheet" & i%), GcSpreadSheet).UpdateLayout()
            grfGraph(i%).RemoveChart("chart" & i%)
            'grfGraph(i%).RemoveChart("chart" & i%)
            'chart(i%) = Nothing

            chart(i%) = New SpreadChart("chart" & i%, SpreadChartType.Line, 0, 0, 200, 160)
            'chart(i%) = New SpreadChart("chart" & i%, SpreadChartType.Line, 0, 0, TryCast(Me.FindName("gcSpreadSheet" & i%), GcSpreadSheet).ActualWidth, TryCast(Me.FindName("gcSpreadSheet" & i%), GcSpreadSheet).ActualHeight)
            chart(i%).PlotArea.Fill = New SolidColorBrush(Colors.Silver)
            chart(i%).Fill = New SolidColorBrush(Colors.Silver)
            '' pick up. Need to resize the font as needed.
            chart(i%).FontSize = 10
            'chart(i%).AxisX.Max = mnMaxPoints - 1
            ' Y Axis Gridline needs to be transparent
            chart(i%).AxisY.MajorGridlinesStroke = New SolidColorBrush(Colors.Transparent)
            'grfGraph(i%).NumPoints = mnMaxPoints
            If (chart(i%).AxisX.Max > 10) Then
                'If (grfGraph(i%).NumPoints > 10) Then
                '' pick up. Fix this so that graph is from 0 to 27 every 3
                'chart(i%).AxisX.tick
                chart(i%).AxisX.Min = 0
                'chart(i%).AxisX.MajorUnit = 3
                'chart(i%).AxisX.Min = Math.Round(chart(i%).AxisX.Max / 10)
                '    grfGraph(i%).TickEvery = grfGraph(i%).NumPoints / 10
            Else
                chart(i%).AxisX.Min = 1
                '    grfGraph(i%).TickEvery = 1
            End If
            '' test code
            '' Pick up. Line below works
            If grfGraph(i%).Charts.Count <> 0 Then
                'grfGraph(i%).Charts.Clear()
            End If
            grfGraph(i%).Charts.Add(chart(i%))
        Next i%
        Call Plot_Graphs()

    End Sub

    Private Sub Plot_Graphs()
        Dim iPt%, iGraph%

        ReDim chartData(8)
        For iData% = 1 To 8
            iGraph% = iData%

            chart(iGraph%).Legend.Alignment = GrapeCity.Windows.SpreadSheet.Data.LegendAlignment.TopCenter
            chart(iGraph%).Legend.Text = "Chart" & iGraph%
            chart(iGraph%).Legend.FontSize = 12

            chartData(iGraph%) = New SpreadDataSeries()

            ' Customize the chart display
            chartData(iGraph%).Name = " "
            chartData(iGraph%).DataLabelSettings = New GrapeCity.Windows.SpreadSheet.Data.DataLabelSettings()
            chartData(iGraph%).DataLabelSettings.ShowSeriesName = False
            chartData(iGraph%).DataLabelSettings.ShowValue = False

            chartData(iGraph%).InvertIfNegative = True

            For iPt% = 0 To (ds.Values.Count - 1)
                chartData(iGraph%).Values.Add(ds.Values(iPt%))
            Next iPt%

            chart(iGraph%).DataSeries.Add(chartData(iGraph%))

        Next iData%
        'grfGraph(iGraph%).Charts.Add(chart(iGraph%))

        gcSpreadSheet1.InvalidateCharts()
        '_selectedChart = Me.GcSpreadSheet1.ActiveSheet.Charts(0)

    End Sub


    Private Sub Test_Click(sender As Object, e As RoutedEventArgs)

        'btnClick = True
        ' Call Init_Graphs()
        Dim i As Integer

        For i = 1 To 8
            Dim firstSheetChart = TryCast(Me.FindName("gcSpreadSheet" & i), GcSpreadSheet).ActiveSheet.Charts(0)
            firstSheetChart.DataSeries.RemoveAt(0)

            Dim ds As New GrapeCity.Windows.SpreadSheet.Data.SpreadDataSeries()
            ds.Values.Add(3)
            ds.Values.Add(-2)
            ds.Values.Add(4)
            ds.Values.Add(7)
            Dim ds2 As New GrapeCity.Windows.SpreadSheet.Data.SpreadDataSeries()
            ds2.Values.Add(6)
            ds2.Values.Add(-7)
            ds2.Values.Add(8)
            ds2.Values.Add(10)
            firstSheetChart.Legend.Alignment = GrapeCity.Windows.SpreadSheet.Data.LegendAlignment.TopCenter
            firstSheetChart.Legend.Text = "Chart" & i
            firstSheetChart.Legend.FontSize = 12



            ' Customize the chart display
            ds.Name = " "
            ds.DataLabelSettings = New GrapeCity.Windows.SpreadSheet.Data.DataLabelSettings()
            ds.DataLabelSettings.ShowSeriesName = False
            ds.DataLabelSettings.ShowValue = False

            ds.InvertIfNegative = True

            For iPt% = 0 To (ds.Values.Count - 1)
                ds.Values.Add(ds.Values(iPt%))
            Next iPt%

            firstSheetChart.DataSeries.Add(ds)
            firstSheetChart.DataSeries.Add(ds2)

        Next i


    End Sub
End Class
